#!/usr/bin/env python
# 
# @Copyright@
# 
# 				Rocks
# 		         www.rocksclusters.org
# 			     Version 3.2.0
# 
# Copyright (c) 2004 The Regents of the University of California. All
# rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# 3. All advertising materials mentioning features or use of this
# software must display the following acknowledgement: This product
# includes software developed by the ROCKS CLUSTER GROUP at the San
# Diego Supercomputer Center and its contributors.
# 
# 4. Neither the name of the Center nor the names of its contributors
# may be used to endorse or promote products derived from this software
# without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
# IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @Copyright@
#
# $Log: select.py,v $
# Revision 1.7  2004/03/25 03:15:02  bruno
# touch 'em all!
#
# update version numbers to 3.2.0 and update copyrights
#
# Revision 1.6  2003/08/27 23:10:55  mjk
# - copyright update
# - rocks-dist uses getArch() fix the i686 distro bug
# - ganglia-python spec file fixes (bad service start code)
# - found some 80col issues while reading code
# - WAN ks support starting
#
# Revision 1.5  2003/02/17 18:43:04  bruno
# updated copyright to 2003
#
# Revision 1.4  2003/02/08 02:22:29  fds
# Added introspective help method.
#
# Revision 1.3  2002/10/18 21:33:25  mjk
# Rocks 2.3 Copyright
#
# Revision 1.2  2002/04/09 05:52:57  mjk
# mds fixes
#
# Revision 1.1  2002/04/09 00:30:51  mjk
# mds changes
#

import gmon.ganglia
import string
import types
import sys

class Base:
	def __init__(self, ganglia, commands, args):
		self.ganglia  = ganglia
		self.commands = commands
		self.args     = args

	def hosts(self):
		return []

	def metrics(self):
		return []

	def help(self):
		pass
		
	def flavors(self):
		selects = []
		for Class in globals().values():
			if type(Class) == types.ClassType:
				if issubclass(Class, Base) and Class != Base:
					selects.append(Class.__name__)
		return selects

class Default(Base):
	def hosts(self):
		return self.ganglia.getCluster().getHosts()

	def metrics(self):
		return self.commands

	def help(self):
		print 'where "metric" is one of:'
		line = ''
		for metric in self.ganglia.getMetricNames():
			if len(line) + len(metric) > 70:
				print '\t%s' % line
				line = ''
			else:
				line = line + ' ' + metric
		print '\t%s' % line


class All(Base):
	def hosts(self):
		return self.ganglia.getCluster().getHosts()

	def metrics(self):
		return self.ganglia.getMetricNames()





