#!/usr/bin/perl
#Voldemort 0.6
#Makefile Writer
#Steve Timm--author
#begun 2/17/03
#Last modified  2/26/03
#The goal of this script is to read the 
#$VOLDEMORT_DIR/clusters/common/db/files.conf file and construct a Makefile
#for every directory in the cluster tree.(at least for files hierarchy)
#Expected format of the files.conf file is colon-separated,
#field 1--path to file, assuming $VOLDEMORT_DIR/clusters
#field 2--files which this file depends on
#field 3--command to get this file in position
#
$slash='/';
$hashopts{'files'}='-P -R -S -T -L';
$hashopts{'RPMS'}='-P -F -S -T -L';
$hashopts{'scripts'}='-P -R -F -T -L';
$hashopts{'prescripts'}='-R -F -S -T -L';
$hashopts{'tarballs'}='-P -R -F -S -L';
#The script can take an argument of a restricted directory name,
# otherwise it will, by default, parse all the files in files.conf.
#Parse the arguments passed to the script:
if ($#ARGV == 0) {
$targetdir=$ARGV[0];
}
else {
$targetdir='';
}
chdir $targetdir;
$cwd= `pwd`;
#print "$cwd \n";
$cwdshort=$cwd;

#get the right environment--$VOLDEMORT_DIR must be set
$voldemortdir=$ENV{VOLDEMORT_DIR};
$cwdshort =~ s/$voldemortdir//;
#print "$cwdshort \n";
#Open the database
open (FILESCONF, "$voldemortdir/clusters/common/db/files.conf");
#
#Main loop:  Read the database
#No assumption is made that all the files in a single directory
#are together.
$ii=0;
while ( $dbline=<FILESCONF> ) { 
	chop;
#        print "dbline $ii\n";
         $ii+=1;  
#        print "$dbline\n";
       if ($dbline !~ m/^#/) {
	($filepath,$filedep,$filecmd)=split(':',$dbline);
# Figure out which directory this file is in:
#         print "filepath: $filepath\n";
#         print "filedep: $filedep\n";
#         print "filecmd: $filecmd\n";
         @dirsplit=split('/',$filepath);
	 $ndir=$#dirsplit;
#         print "ndir: $ndir\n";
         $curfile=$dirsplit[$ndir];
         $curdir=$dirsplit[$ndir-1];	
#         print "curfile: $curfile\n";
#         print "curdir: $curdir\n";
         @tree="";
         $jj=0;
         $buildpath='';
         foreach $dir  (@dirsplit) {
                if ($jj == 0 ) { 
                $buildpath=$dir;
                $jj+=1;
                }
                else
                {
         	$buildpath=$buildpath.$slash.$dir;
         	$tree[$jj]=$buildpath;
#         	print "$tree[$jj]\n";
         	$jj+=1;
                }
        }
         push @filestomake, $filepath;
#         print "tree-1: $tree[$ndir-1]\n";
         $indirstomake=0;
         foreach $ddir (@dirstomake) {
              if ( $ddir eq $tree[$ndir-1] ) {
                  $indirstomake=1;
              }
              }
         if ($indirstomake == 0 ) { 
         push @dirstomake, $tree[$ndir-1];
         }
         if ( substr($filepath,-1) eq $slash ) {
               	print "subdirectory $filepath \n";
               	$hashsubdir{$tree[$ndir-1]}=$hashsubdir{$tree[$ndir-1]}.' '.$curfile;               
           }
         else {
	       print "file $filepath \n";
               $hashdep{$filepath}=$filedep;
               $hashcmd{$filepath}=$filecmd;
               $hashdirfiles{$tree[$ndir-1]}=$hashdirfiles{$tree[$ndir-1]}.' '.$curfile;
               $hashdirpaths{$tree[$ndir-1]}=$hashdirpaths{$tree[$ndir-1]}.' '.$filepath;
           }
          }
}        
#       print "filestomake:\n";
#       print "@filestomake \n";
#       print "dirstomake:\n";
#       print "@dirstomake \n";
#       print "hashsubdir:\n";
#       print %hashsubdir;
#       print "\n hashdirfiles: \n";
#       print %hashdirfiles;
#       print "\n hashdirpaths: \n";
#       print %hashdirpaths;
#       print "\n hashdep: \n";
#       print %hashdep;
#       print "\n hashcmd: \n";
#       print %hashcmd;
#have read through whole file, now start writing out Makefiles
      foreach $dir (@dirstomake) {
       print "\n dir: $dir \n";
       ($dcluster,$dcategory,$dflavor,$remainder)=split('/',$dir);
       chdir "$voldemortdir/clusters/$dir";
       open (OUTMAKE,">Makefile");
#      Write prologue
       $outdate=`date`;
       print OUTMAKE "#Makefile for $dir automatically generated by Voldemort's makefile_writer.pl $outdate \n";
#  First line "all"
       $all="all: ";
# First_a line "content"
	$content="content: ";
       if ( $hashsubdir{$dir} ne '' ) {
       $all=$all.'subdirs ';
       $content=$content.'subdirs ';
       }
       if ( $hashdirfiles{$dir} ne '' ) {
       $all=$all.'dirfiles ';
       $content=$content.'dirfiles ';
       }
       print OUTMAKE "$all push\n\n";
       print OUTMAKE "$content \n\n";

#  Second line "dirfiles"
        if ( $hashdirfiles{$dir} ne '' ) {
        print OUTMAKE "dirfiles: $hashdirfiles{$dir}\n";
#  Now loop over the dirfiles one by one and print out 
#  the rule for each file
       @dirfilelist=split(' ',$hashdirfiles{$dir});
       @dirpathlist=split(' ',$hashdirpaths{$dir});
       $jj=0;
       foreach $dirfile (@dirfilelist) {
                $dirpath=$dirpathlist[$jj];
#                print "$dirpath\n";
#                print "$hashdep{$dirpath}\n";
#                print "$hashcmd{$dirpath}\n";
		print OUTMAKE "$dirfile: $hashdep{$dirpath}\n";
		print OUTMAKE "\t\@$hashcmd{$dirpath}\n\n";
                $jj+=1;
		}
       }
#   Third line "subdirs"
       if ( $hashsubdir{$dir} ne '' ) {
	print OUTMAKE "subdirs: $hashsubdir{$dir}\n\n";
#   Now loop over the subdirs one by one.
	@subdirlist=split(' ',$hashsubdir{$dir});
        foreach $subdir (@subdirlist) {
		print OUTMAKE "$subdir: $subdir/Makefile \n";
		print OUTMAKE "\t".'@cd '."$subdir ; make content\n \n";
        }
        }
#    Fourth line "push"
        print OUTMAKE "push:\n";
        print OUTMAKE "\t\@rsync_push -c $dcluster -f $dflavor $hashopts{'$dcategory'}\n";
      close (OUTMAKE);
}

#
