#!/usr/bin/perl
#This script is designed to average the temperatures in temp.log
#to calculate the baseline loaded and idle temperatures
#for each machine in the farms individually.
$nfan=$ARGV[0];
print "$nfan \n";
$sqidleavg1=0;
$sqidleavg2=0;
$idleavg1=0;
$idleavg2=0;
$idlen=0;
$sqloadsum1=0;
$sqloadsum2=0;
$loadsum1=0;
$loadsum2=0;
$loadn=0;
foreach $tempfile ('/var/log/temp.log','/var/log/temp.log.1','/var/log/temp.log.2','/var/log/temp.log.3','/var/log/temp.log.4') 
{
open (IN,$tempfile);
while (<IN>) {
chomp;
if ($nfan==0) 
{
($indate,$intime,$tempcpu1,$tempcpu2,$load1,$load5,$load10,$pid,$swap)=split(' ',$_); 
}
elsif ($nfan==1)
{
($indate,$intime,$tempcpu1,$tempcpu2,$fan1,$load1,$load5,$load10,$pid,$swap)=split(' ',$_); 
}
elsif ($nfan==2)
{
($indate,$intime,$tempcpu1,$tempcpu2,$fan1,$fan2,$load1,$load5,$load10,$pid,$swap)=split(' ',$_); 
}
elsif ($nfan==3)
{
($indate,$intime,$tempcpu1,$tempcpu2,$fan1,$fan2,$fan3,$load1,$load5,$load10,$pid,$swap)=split(' ',$_);
}
elsif ($nfan==4)
{
($indate,$intime,$tempcpu1,$tempcpu2,$fan1,$fan2,$fan3,$fan4,$load1,$load5,$load10,$pid,$swap)=split(' ',$_); 
}
elsif ($nfan==5)
{
($indate,$intime,$tempcpu1,$tempcpu2,$fan1,$fan2,$fan3,$fan4,$fan5,$load1,$load5,$load10,$pid,$swap)=split(' ',$_); 
}
elsif ($nfan==6)
{
($indate,$intime,$tempcpu1,$tempcpu2,$fan1,$fan2,$fan3,$fan4,$fan5,$fan6,$load1,$load5,$load10,$pid,$swap)=split(' ',$_); 
}
else
{ exit; }

print "$tempcpu1,$tempcpu2,$load10\n";
if (( $tempcpu1 != 0 ) && ( $tempcpu2 != 0 ) && ( $tempcpu1 < 250 ) && ( $tempcpu2 < 250 ) ) 
{
if ( $load10 >= 2 ) 
	{ $loadn+=1;
	  $loadsum1+=$tempcpu1;
	  $loadsum2+=$tempcpu2;
          $sqloadsum1=$sqloadsum1+($tempcpu1*$tempcpu1);
	  $sqloadsum2=$sqloadsum2+($tempcpu2*$tempcpu2);
#	  print "$loadsum1 $loadsum2 $sqloadsum1 $sqloadsum2 \n";
          }
elsif ($load10 < 1 )
	{ $idlen+=1;
	  $idlesum1+=$tempcpu1;
	  $idlesum2+=$tempcpu2;
 	  $sqidlesum1=$sqidlesum1+($tempcpu1*$tempcpu1);
          $sqidlesum2=$sqidlesum2+($tempcpu2*$tempcpu2);
        }
}
}
}
if ( $idlen > 1 )
{
#print "$idlesum1 $idlen $sqidlesum1 \n";
$idleavg1=$idlesum1/$idlen;
#print "$idleavg1 \n";

$idlevar1=(($idlen*$sqidlesum1)-($idlesum1*$idlesum1))/($idlen*($idlen-1));
#print "$idlevar1 \n";
$idlestd1=sqrt($idlevar1);
#print "$idlestd1 \n";
#print "$idlesum2 $idlen $sqidlesum2 \n";
$idleavg2=$idlesum2/$idlen;
$idlevar2= (($idlen*$sqidlesum2)-($idlesum2*$idlesum2))/($idlen*($idlen-1));
#print "$idlevar2 \n";
$idlestd2=sqrt($idlevar2 );
#print "$idlestd2 \n";
}
else
  {
$idleavg1=-1;
$idleavg2=-1;
}
if ($loadn > 1)
{
#print "$loadsum1 $loadn $sqloadsum1 \n";
$loadavg1=$loadsum1/$loadn;
#print "$loadavg1 \n";
$loadvar1=(($loadn*$sqloadsum1)-($loadsum1*$loadsum1))/($loadn*($loadn-1));
#print "$loadvar1 \n";
$loadstd1=sqrt($loadvar1);
#print "$loadsum2 $loadn $sqloadsum2 \n";
$loadavg2=$loadsum2/$loadn;
#print "$loadavg2 \n";
$loadvar2=(($loadn*$sqloadsum2)-($loadsum2*$loadsum2))/($loadn*($loadn-1));
#print "$loadvar2 \n";
$loadstd2=sqrt($loadvar2);
#print "$loadstd2 \n";
}
else
{
$loadavg1=-1;
$loadavg2=-1;
}
open (OUT, '>/etc/hwtype.node');
print OUT "#!/bin/sh\n";
print "average loaded temperatures: \n";
print "$loadavg1 +/- $loadstd1   $loadavg2 +/- $loadstd2  N=$loadn \n";
print "average idle temperatures: \n";
print "$idleavg1 +/- $idlestd1   $idleavg2 +/- $idlestd2  N=$idlen \n";
print OUT "# average loaded temperatures: \n";
print OUT "# $loadavg1 +/- $loadstd1   $loadavg2 +/- $loadstd2  N=$loadn \n";
print OUT "# average idle temperatures: \n";
print OUT "# $idleavg1 +/- $idlestd1   $idleavg2 +/- $idlestd2  N=$idlen \n";
#Add 3 sigma to the threshold
$loadavg1=int($loadavg1+3*$loadstd1);
$loadavg2=int($loadavg2+3*$loadstd2);
$idleavg1=int($idleavg1+3*$idlestd1);
$idleavg2=int($idleavg2+3*$idlestd2);
if ($idleavg1 != -1) 
{
print OUT "CPU1_IDLE=$idleavg1\n";
}
if ($idleavg2 != -1) 
{
print OUT "CPU2_IDLE=$idleavg2\n";
}
if ($loadavg1 != -1)
{
print OUT "CPU1_LEVEL=$loadavg1\n";
}
if ($loadavg2 != -1)
{
print OUT "CPU2_LEVEL=$loadavg2\n";
}
close (OUT);
chmod 0755, '/etc/hwtype.node';


