#!/usr/bin/perl
##################################################
#Determine if we are running LILO or GRUB as default boot loader
#(grubby doesn't tell us that under 7.3)
#Boot sector will contain GRUB if it is grub,
#won't if it isn't.
##################################################
$grubbootdrive="";
$lilobootdrive="";
if ( -r "/boot/grub/grub.conf" )
{
	$grubbootline=`grep 'boot=' /boot/grub/grub.conf`;
	chop $grubbootline;
        ($grubtext,$grubbootdrive)=split("=",$grubbootline);
}
if ( -r "/etc/lilo.conf" ) 
{ 
	$lilobootline=`grep 'boot=' /etc/lilo.conf`;
	chop $lilobootline;
	($lilotext,$lilobootdrive)=split('=',$lilobootline);
}
$bootsect="";
if ($grubbootdrive ne "")
{
        $grubbootsect=`dd if=$grubbootdrive count=1 bs=512 2>/dev/null | grep GRUB`;
	if ( $grubbootsect ne "")
        {
            $bloader="GRUB";
        }
}
if (($grubbootsect eq "") && ($lilobootdrive ne ""))
{
	$lilobootsect=`dd if=$lilobootdrive count=1 bs=512 2>/dev/null | grep LILO`;
        if ($lilobootsect ne "")
	{
		$bloader="LILO";
#	    	print "bloader $bloader\n";
        }
}

if ($bloader eq "GRUB")
{

#should allow for the fact that /boot/grub/grub.conf can 
#be a symlink, also save a copy of previous file.
chdir ("/boot/grub");
$grubfile="grub.conf";
if ( -l $grubfile) 
{ 
$grublink=$grubfile;
$grubfile=readlink($grublink);
}
system "cp -p $grubfile $grubfile.remove_memtest.sav";

#
# Check for previous versions of memtest line in grub.conf
#
#print "bloader $bloader\n";
$prevgrub=`grep 'kernel /boot/memtest' /boot/grub/grub.conf | awk '{print $2}'`;
# Remove previous versions of the memtest line
if ( $prevgrub ne "")
{
@prevgrublines=split("\n",$prevgrub);
foreach $prevline (@prevgrublines)
{
$prevline=~ s/ //g;
$prevline=~ s/kernel//g;
$prevline=~ s/\t//g;
$lenprev=length($prevline);
system "grubby --remove-kernel=$prevline --output-file=$grubfile";
chmod 0600, $grubfile;
}
}
}
####################################################
# Modify /etc/lilo.conf
####################################################
if ($bloader eq "LILO")
{
open (LILO,"/etc/lilo.conf");
while ($ThisLine = <LILO>) {
   # If there is already a 'label=memtest86' line, delete it
   if ($ThisLine =~ m/label=memtest86/ ) {
      print "removing label=memtest86 line from  lilo.conf...\n";
      $ThisLine='';
      $Memtestlinepresent = 1;
   }
   # If there is already an image line, delete it
   if ($ThisLine =~ m/image.*memtest/ ) {
#        print "ThisLine: \n";
#        print "$ThisLine:";
#        print "newimageline: \n";
#        print "$newimageline";
      $ThisLine='';
      $imagelinepresent=1;
    }
   # Store lilo line...
   push @lilo, $ThisLine;

}
close (LILO);

# open /etc/lilo.conf for writing
open (LILO,">/etc/lilo.conf");

# Write file...
foreach $ThisLine (@lilo) {
   print LILO $ThisLine;

}
close (LILO);

print "\nWrote /etc/lilo.conf and now running lilo...\n";
system("/sbin/lilo");

}