#!/usr/bin/perl
#This perl script is to undo the effects of the zz_remove_message rpm
#namely, putting the "message=/boot/message" line back into 
# /etc/lilo.conf or /boot/grub/grub.conf 
#if the zz_remove_message rpm should ever be uninstalled
##################################################
#Determine if we are running LILO or GRUB as default boot loader
#(grubby doesn't tell us that under 7.3)
#Boot sector will contain GRUB if it is grub,
#won't if it isn't.
##################################################
$grubbootdrive="";
$lilobootdrive="";
if ( -r "/boot/grub/grub.conf" )
{
	$grubbootline=`grep 'boot=' /boot/grub/grub.conf`;
	chop $grubbootline;
#	print "grubbootline\n";
#	print "$grubbootline\n";
        ($grubtext,$grubbootdrive)=split("=",$grubbootline);
#        print "grubbootdrive\n";
#        print "$grubbootdrive\n";
}
if ( -r "/etc/lilo.conf" ) 
{ 
	$lilobootline=`grep 'boot=' /etc/lilo.conf`;
	chop $lilobootline;
#	print "lilobootline\n";
#	print "$lilobootline\n";
	($lilotext,$lilobootdrive)=split('=',$lilobootline);
#        print "lilobootdrive\n";
#	print "$lilobootdrive\n";
}
$bootsect="";
if ($grubbootdrive ne "")
{
        $grubbootsect=`dd if=$grubbootdrive count=1 bs=512 2>/dev/null | grep GRUB`;
#	print "grubbootsect\n";
#	print "$grubbootsect\n";
	if ( $grubbootsect ne "")
        {
            $bloader="GRUB";
#	    print "bloader $bloader\n";
        }
}
if (($grubbootsect eq "") && ($lilobootdrive ne ""))
{
	$lilobootsect=`dd if=$lilobootdrive count=1 bs=512 2>/dev/null | grep LILO`;
#	print "lilobootsect\n";
#	print "$lilobootsect\n";
        if ($lilobootsect ne "")
	{
		$bloader="LILO";
#	    	print "bloader $bloader\n";
        }
}

if ($bloader eq "GRUB")
{
$MessageLineDone = 0;
#should allow for the fact that /boot/grub/grub.conf can 
#be a symlink, also save a copy of previous file.
chdir ("/boot/grub");
$grubfile="grub.conf";
if ( -l $grubfile) 
{ 
$grublink=$grubfile;
$grubfile=readlink($grublink);
}
system "cp -p $grubfile $grubfile.zz_add_message.sav";
open (GRUB, "$grubfile");
while ($ThisLine = <GRUB>)
{
   # If there is already a 'splashimage' line, change it...
   if ($ThisLine =~ m/^\#splashimage/ ) {
      print "Uncommenting splashimage line in grub.conf...\n";
      $ThisLine=substr($ThisLine,1);
      $MessageLineDone = 1;
}
   # Store grub line
     push @grub,$ThisLine;
}
close (GRUB);
# open $grubfile  for writing
open (GRUB,">$grubfile");

# Write file...
foreach $ThisLine (@grub) {
   print GRUB $ThisLine;

}
close (GRUB);

}
if ($bloader eq "LILO")
{
$newmessageline="message=/boot/message\n";
####################################################
# Modify /etc/lilo.conf
####################################################
system "cp /etc/lilo.conf /etc/lilo.conf.zz_add_message.sav";
$MessageLineDone = 0;
open (LILO,"/etc/lilo.conf");
while ($ThisLine = <LILO>) {
   # If there is already a 'message=' line, do nothing...
   if ($ThisLine =~ m/message=/ ) {
      print "message=/boot/message line in lilo.conf is already there...\n";
      $MessageLineDone = 1;
   }

   # Store lilo line...
   push @lilo, $ThisLine;

}
close (LILO);

# open /etc/lilo.conf for writing
open (LILO,">/etc/lilo.conf");

# Write file...
# message line has to be added right after timeout line
foreach $ThisLine (@lilo) {
   print LILO $ThisLine;
   if ( $ThisLine =~ /^timeout/ ) {
      if ( $MessageLineDone != 1 ) { 
          print LILO $newmessageline;
      }
      }
}
close (LILO);

print "\nWrote /etc/lilo.conf and now running lilo...\n";
system("/sbin/lilo");
}
