#!/usr/bin/perl
##################################################
#Determine if we are running LILO or GRUB as default boot loader
#(grubby doesn't tell us that under 7.3)
#Boot sector will contain GRUB if it is grub,
#won't if it isn't.
##################################################
$grubbootdrive="";
$lilobootdrive="";
if ( -r "/boot/grub/grub.conf" )
{
	$grubbootline=`grep 'boot=' /boot/grub/grub.conf`;
	chop $grubbootline;
#	print "grubbootline\n";
#	print "$grubbootline\n";
        ($grubtext,$grubbootdrive)=split("=",$grubbootline);
#        print "grubbootdrive\n";
#        print "$grubbootdrive\n";
}
if ( -r "/etc/lilo.conf" ) 
{ 
	$lilobootline=`grep 'boot=' /etc/lilo.conf`;
	chop $lilobootline;
#	print "lilobootline\n";
#	print "$lilobootline\n";
	($lilotext,$lilobootdrive)=split('=',$lilobootline);
#        print "lilobootdrive\n";
#	print "$lilobootdrive\n";
}
$bootsect="";
if ($grubbootdrive ne "")
{
        $grubbootsect=`dd if=$grubbootdrive count=1 bs=512 2>/dev/null | grep GRUB`;
#	print "grubbootsect\n";
#	print "$grubbootsect\n";
	if ( $grubbootsect ne "")
        {
            $bloader="GRUB";
#	    print "bloader $bloader\n";
        }
}
if (($grubbootsect eq "") && ($lilobootdrive ne ""))
{
	$lilobootsect=`dd if=$lilobootdrive count=1 bs=512 2>/dev/null | grep LILO`;
#	print "lilobootsect\n";
#	print "$lilobootsect\n";
        if ($lilobootsect ne "")
	{
		$bloader="LILO";
#	    	print "bloader $bloader\n";
        }
}

if ($bloader eq "GRUB")
{
$MessageLineDone = 0;
#should allow for the fact that /boot/grub/grub.conf can 
#be a symlink, also save a copy of previous file.
chdir ("/boot/grub");
$grubfile="grub.conf";
if ( -l $grubfile) 
{ 
$grublink=$grubfile;
$grubfile=readlink($grublink);
}
system "cp -p $grubfile $grubfile.zz_remove_message.sav";
open (GRUB, "$grubfile");
while ($ThisLine = <GRUB>)
{
   # If there is already a 'splashimage' line, change it...
   if ($ThisLine =~ m/^splashimage/ ) {
      print "Commenting out splashimage line in grub.conf...\n";
      $ThisLine="#$ThisLine";
      $MessageLineDone = 1;
}
   # Store grub line
     push @grub,$ThisLine;
}
close (GRUB);
# open $grubfile  for writing
open (GRUB,">$grubfile");

# Write file...
foreach $ThisLine (@grub) {
   print GRUB $ThisLine;

}
close (GRUB);

}

####################################################
# Modify /etc/lilo.conf
####################################################
if ($bloader eq  "LILO") 
{
#Save a copy of lilo.conf as it was before:
system "cp -p /etc/lilo.conf /etc/lilo.conf.zz_remove_message.sav";
$MessageLineDone = 0;
open (LILO,"/etc/lilo.conf");
while ($ThisLine = <LILO>) {
   # If there is already a 'message=' line, change it...
   if ($ThisLine =~ m/message=/ ) {
      print "Modifying message=/boot/message line in lilo.conf...\n";
      $ThisLine='';
      $MessageLineDone = 1;
   }

   # Store lilo line...
   push @lilo, $ThisLine;

}
close (LILO);


# open /etc/lilo.conf for writing
open (LILO,">/etc/lilo.conf");

# Write file...
foreach $ThisLine (@lilo) {
   print LILO $ThisLine;

}
close (LILO);

print "\nWrote /etc/lilo.conf and now running lilo...\n";
system("/sbin/lilo");

}